import {IBuildSystemConfiguration, IBuildSystemPathsConfiguration} from "./index";

export const DefaultBuildSystemConfig: IBuildSystemConfiguration<IBuildSystemPathsConfiguration> = {
  suppressErrors: false,
  backupSetupFiles: true,
  paths: {
    root: '.',
    source: 'src/',
    tests: 'test/',
    output: 'dist/',
    testOutput: 'dist-test/',
    doc: 'doc/',
    setup: '.',
    changelog: './CHANGELOG.md',
  },
  conventionalTasks: {
    clean: {
      help: 'Cleans up all files generated by the build system.',
      tasksBefore: []
    },
    lint: {
      help: 'Applies linting to the source files',
      tasksBefore: []
    },
    build: {
      help: 'Builds all source files',
      tasksBefore: ['clean']
    },
    test: {
      help: 'Builds and runs all test files',
      tasksBefore: ['build']
    },
    doc: {
      help: 'Generates documentation',
      tasksBefore: []
    },
    'setup-dev': {
      help: 'Copies typical .files for your plugins.',
      tasksBefore: []
    },
    watch: {
      help: 'Watches source files for changes and executes a certain task.',
      tasksBefore: ['build']
    },
  },
};
